import { ILifetime } from '../Lifetime';
import { IServiceProvider } from '../ServiceProvider';
import { MockSetup } from './mockUtils';
import { DependencyOptions, Key, LifetimeConstructor, Selector, Stateful, StatefulDependencyOptions } from './types';
export declare class ServiceCollection<E = {}> {
    private readonly self;
    private readonly lifetimes;
    constructor(other?: ServiceCollection, lifetime?: ILifetime<any, E>);
    addStateful<T, KE, P>(name: keyof KE & Key<KE> & (keyof KE extends keyof E ? never : any), Dependency: StatefulDependencyOptions<T, P, {
        [key in keyof KE]: Stateful<P, T>;
    } & E>): ServiceCollection<{ [key in keyof KE | keyof E]: key extends keyof KE ? Stateful<P, T> : key extends keyof E ? E[key] : never; }>;
    addSingleton<T, KE>(name: keyof KE & Key<KE> & (keyof KE extends keyof E ? never : any), Dependency: DependencyOptions<T, E>): ServiceCollection<{ [key in keyof E | keyof KE]: key extends keyof KE ? T : key extends keyof E ? E[key] : never; }>;
    addScoped<T, KE>(name: keyof KE & Key<KE> & (keyof KE extends keyof E ? never : any), Dependency: DependencyOptions<T, E>): ServiceCollection<{ [key in keyof E | keyof KE]: key extends keyof KE ? T : key extends keyof E ? E[key] : never; }>;
    addTransient<T, KE>(name: keyof KE & Key<KE> & (keyof KE extends keyof E ? never : any), Dependency: DependencyOptions<T, E>): ServiceCollection<{ [key in keyof E | keyof KE]: key extends keyof KE ? T : key extends keyof E ? E[key] : never; }>;
    add<T, KE>(Lifetime: LifetimeConstructor, name: keyof KE & Key<KE> & (keyof KE extends keyof E ? never : any), Dependency: DependencyOptions<T, E>): ServiceCollection<{
        [key in keyof E | keyof KE]: key extends keyof KE ? T : key extends keyof E ? E[key] : never;
    }>;
    get<T>(selector: Selector<T, E>): ILifetime<T, E> | undefined;
    remove<T, KE>(selector: Selector<T, E, KE>): ServiceCollection<Omit<E, keyof KE>>;
    build(): IServiceProvider<E>;
    buildMock(mock?: MockSetup<E>): IServiceProvider<E>;
    private extractFactory;
    private cloneLifetimes;
}
